package stockMarketApplet.GUI;

import javax.swing.*;
import java.awt.event.*;
import java.awt.*;
import java.util.*;
import java.applet.*;
import javax.swing.JFrame;
import stockMarketApplet.GUI.*;
import stockMarketApplet.util.*;
import stockMarketApplet.market.*;


// This class opens a window with an Text Field to fill with the number of group to edit.
// When the OK button is pressed, the changed values are directly set in
public class OptGroupNumFrame extends Frame implements ActionListener{

  private GridBagLayout gridbag;
  private JPanel lpanel, buttonpanel;
  private JComboBox groupNumChoices;

  private Button okbutton;
  private Button cancelbutton;
  private Market market;
  private OptFrame frame;
  private int maxNumGroups;

  private OptTechnicalFrame opttechnicalframe;


  // Create an instance of OptFrame, using the provided String as title, the Pool object
  // as reference to the pool whose value are to be changed and a reference to the
  public OptGroupNumFrame(String title, Market market, OptFrame frame, int maxNumGroups)
  {
    super(title);
    this.setBackground(Color.lightGray);
    this.market = market;
    this.frame = frame;
    this.maxNumGroups = maxNumGroups;
    gridbag= new GridBagLayout();
    setLayout(gridbag);
    Util util = new Util();
    lpanel= new JPanel();
    lpanel.setLayout(gridbag);
    lpanel.setBackground(Color.lightGray);
    buttonpanel= new JPanel();
    buttonpanel.setLayout(gridbag);
    buttonpanel.setBackground(Color.lightGray);

    GridBagConstraints c = new GridBagConstraints();

    String [] numbers;
    numbers = new String[maxNumGroups];
    for (int i = 0 ; i < maxNumGroups; i++){
      numbers[i] = ""+i;
    }
    groupNumChoices = new JComboBox(numbers);
    groupNumChoices.setSelectedIndex(0);
    groupNumChoices.addActionListener(this);
    util.constraints(lpanel, groupNumChoices, c, 0, 0, GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER, 1, 1);

    util.constrain(buttonpanel, okbutton= new Button("Ok"), 0, 0, 1, 1, 5, 10, 0, 0);
    util.constrain(buttonpanel, cancelbutton= new Button("Cancel"), 1, 0, 1, 1, 5, 10, 0, 0);
    util.constrain(this, new Label("Enter the Group Number to Edit"), 0, 0, 4, 1,
	      GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER, 1.0, 0.0, 0, 100, 0, 100);
    util.constrain(this, lpanel, 0, 1, 1, 1,
	      GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER, 1.0, 0.0, 0, 0, 0, 0);
    util.constrain(this, buttonpanel, 0, 2, 2, 1,
	      GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER, 1.0, 1.0, 0, 0, 0, 0);
    pack();
  }

  // Handle input events
  public boolean action(Event e, Object arg)
  {
    if(e.target == okbutton)
    {
      if (opttechnicalframe == null)
      {
        opttechnicalframe = new OptTechnicalFrame("Technical Traders Parameters Edition", market, this, groupNumChoices.getSelectedItem().toString());
        opttechnicalframe.show();
      } else
      {
        opttechnicalframe = new OptTechnicalFrame("Technical Traders Parameters Edition", market, this, groupNumChoices.getSelectedItem().toString());
        opttechnicalframe.show();
      }
      return true;
    } else if(e.target == cancelbutton)
    {
      this.dispose();
      try{
        this.finalize();
      }catch (Throwable ee )
      {
        System.out.println("Throw exeption ");
      }
      return true;
    } else
      return false;
  }

  // Implementation of ActionListener interface.
  public void actionPerformed(ActionEvent event) {
    if ("comboBoxChanged".equals(event.getActionCommand())) {
      // update the icon to display the new phase
      opttechnicalframe = new OptTechnicalFrame("Technical Traders Parameters Edition", market, this, groupNumChoices.getSelectedItem().toString());
      opttechnicalframe.show();
      this.dispose();
      try{
        this.finalize();
      }catch (Throwable ee )
      {
        System.out.println("Throw exeption ");
      }
    }
  }

}