package stockMarketApplet.GUI;

import java.awt.*;

public class Scroller extends Panel
{
  private BorderLayout bord;
  private Scrollbar bar;
  private TextField text;
  private int minval, maxval;

  public Scroller(String name, int min, int max, int init)
  {
    bord= new BorderLayout();
    setLayout(bord);

    add("North", new Label(name));
    // add(new Label(""));
    add("Center", bar= new Scrollbar(Scrollbar.HORIZONTAL, init, 10, min, max));
    add("East", text= new TextField(""+ init, 4));

    minval= min; maxval= max;
  }

  public int getValue()
  {
    return bar.getValue();
  }

  public boolean handleEvent(Event e)
  {
    if(e.target == bar)
    {
      switch(e.id)
      {
      case Event.SCROLL_LINE_UP:
      case Event.SCROLL_LINE_DOWN:
      case Event.SCROLL_PAGE_UP:
      case Event.SCROLL_PAGE_DOWN:
      case Event.SCROLL_ABSOLUTE:
	text.setText("" + ((Integer) e.arg).intValue());
	break;
      }
      return true;
    } else if(e.target == text)
    {
      if( e.id == Event.ACTION_EVENT || e.id == Event.LOST_FOCUS)
      {
	int i;

	try {
	  i= Integer.valueOf(text.getText()).intValue();
	}
	catch (NumberFormatException nf)
	{
	  i= -1;
	}

	if((i >= minval) && (i <= maxval))
	{
	  text.setText("" + i);
	  bar.setValue(i);
	}
	else
	  text.setText("" + bar.getValue());

	return true;

      }
    }
    return true;
//    return super.processEvent(new AWTEvent(e));
  }
}

