package stockMarketApplet.GUI;

import java.util.*;
import java.applet.*;
import java.awt.*;

// Display the values of statistical information on the current generation.
public class StatPanel extends Panel {
  private Label popLabel;
  private Label bwLabel;
  private Label awLabel;
  private Label wwLabel;
  private Label asLabel;
  private GridLayout layouter;
  private Font smallfont;
  // Create StatPanel, all values set to zero.
  public StatPanel()
  {
    smallfont= new Font("Courier",Font.PLAIN,12);
    setFont(smallfont);
    layouter= new GridLayout(2, 6);
    setLayout(layouter);
    add(new Label("Ind."));
    add(new Label("best Wealth"));
    add(new Label("avg. Wealth"));
    add(new Label("worst Wealth"));
    add(new Label("avg. Size"));
    popLabel= new Label("0");
    add(popLabel);
    bwLabel= new Label("0");
    add(bwLabel);
    awLabel= new Label("0");
    add(awLabel);
    wwLabel= new Label("0");
    add(wwLabel);
    asLabel= new Label("0");
    add(asLabel);
  }
  // Set size of population
  public void setPop(int i)
  {
    popLabel.setText(""+ i);
  }
  // Best fitness of current generation
  public void setBestWealth(double d)
  {
    bwLabel.setText(""+ d);
  }
  // Average fitness of current generation
  public void setAverageWealth(double d)
  {
    awLabel.setText(""+ d);
  }
  // Worst fitness of current generation
  public void setWorstWealth(double d)
  {
    wwLabel.setText(""+ d);
  }
  // Average size of current generation
  public void setAverageSize(int i)
  {
    asLabel.setText(""+ i);
  }
  // Set all possible values in one step
  public void setValues(int pop, double b, double w, double a, int s)
  {
    setPop(pop);
    setBestWealth(b);
    setWorstWealth(w);
    setAverageWealth(a);
    setAverageSize(s);
    repaint();
  }
  // Reset all values to zero
  public void clear()
  {
    setPop(0);
    setBestWealth(0.0);
    setWorstWealth(0.0);
    setAverageWealth(0.0);
    repaint();
  }

}