package stockMarketApplet.market.agents;

import stockMarketApplet.market.io.*;

public class NoisyTrader {

  private  final byte BUY  = 1;
  private  final byte SELL = -1;
  private  final byte HOLD = 0;
  private double cash;
  private double numberShares;
  private double wealth;
  private double probabilityBuy;
  private double probabilitySell;
  private double probabilityHold;
  private byte decision;

  public NoisyTrader(NoisyTraderParametersRecord noisyParamRec) {
    this.cash = noisyParamRec.getCash();
    this.numberShares = noisyParamRec.getNumberShares();
    this.probabilityBuy = noisyParamRec.getProbabilityBuy();
    this.probabilitySell = noisyParamRec.getProbabilitySell();
    this.probabilityHold = noisyParamRec.getProbabilityHold();
  }
  public double getCash(){
    return this.cash;
  }
  public double getNumberShares(){
    return this.numberShares;
  }
  public double getWealth(){
    return this.wealth;
  }
  public double getProbabilityBuy(){
    return this.probabilityBuy;
  }
  public double getProbabilitySell(){
    return this.probabilitySell;
  }
  public double getProbabilityHold(){
    return this.probabilityHold;
  }
  public byte getDecision(){
    return this.decision;
  }
  public void setCash(double cash){
    this.cash = cash;
  }
  public void setNumberShares(double numberShares){
    this.numberShares = numberShares;
  }
  public void setWealth(double wealth){
    this.wealth = wealth;
  }
  public void setProbabilityBuy(double probabilityBuy){
    this.probabilityBuy = probabilityBuy;
  }
  public void setProbabilitySell(double probabilitySell){
    this.probabilitySell = probabilitySell;
  }
  public void setProbabilityHold(double probabilityHold){
    this.probabilityHold = probabilityHold;
  }
  public void setDecision(byte decision){
    this.decision = decision;
  }
  public byte takeDesicion(double randNumber){
    if (randNumber<=this.probabilitySell){
      decision = SELL;
    }
    else if ( (randNumber>this.probabilitySell) && (randNumber<=(this.probabilitySell+this.probabilityBuy)) ){
      decision = BUY;
    }
    else{
      decision = HOLD;
    }
    return decision;
  }

}