package stockMarketApplet.market.agents.technicalTrader.basics;

import java.util.List;
import java.util.ArrayList;
import stockMarketApplet.market.io.DataRecord;

public class Program extends Object {
  //  Valiable to hold the stored expresion
  private List expression = new ArrayList();
  //  Variable for storing the value of this program
  private byte value;
  //  Set that contains the functions
  private List functionSet = new ArrayList();
  //  Set that contains the indicators
  private List indicatorSet = new ArrayList();
  //  Set that contains the decisions
  private List decisionSet = new ArrayList();
  private  final byte BUY       = 1;
  private  final byte SELL      = -1;
  private  final byte HOLD      = 0;
  private  final double EPSILON = 0.10;
  //
  public Program(){
    functionSet.add("ITE");
    functionSet.add("AND");
    functionSet.add("OR");
    functionSet.add("NOT");
    functionSet.add("<");
    functionSet.add(">");
    functionSet.add("=");
    indicatorSet.add("MV_12");
    indicatorSet.add("MV_50");
    indicatorSet.add("Filter_5");
    indicatorSet.add("Filter_63");
    indicatorSet.add("TRB_5");
    indicatorSet.add("TRB_50");
    indicatorSet.add("VOL_12");
    indicatorSet.add("VOL_50");
    indicatorSet.add("MOM_10");
    indicatorSet.add("MOM_60");
    indicatorSet.add("MMA_10");
    indicatorSet.add("MMA_60");
    decisionSet.add("BUY");
    decisionSet.add("SELL");
    decisionSet.add("HOLD");
  }
  // Constructor with an expression as a parameter
  public Program(List expression){
    this();
    this.expression.addAll(expression);
  }
  // Constructor with an expression and a value as parameters
  public Program(List expression, byte value){
    this();
    this.expression.addAll(expression);
    this.value = value;
  }
  //  Method to get the stored expression of this program
  public List getExpression(){
    return this.expression;
  }
  //  Method to get the stored value of this program
  public byte getValue(){
    return this.value;
  }
  //
  public List getIndicatorSet(){
    return this.indicatorSet;
  }
  //
  public List getDecisionSet(){
    return this.decisionSet;
  }
  //
  public short getNumberArgs(){
    String tmpStr = (String)this.expression.get(0);
    short tmpShort = 0;
    if (tmpStr.compareTo("ITE")==0){
      tmpShort = 3;
    }
    else if (tmpStr.compareTo("NOT")==0){
      tmpShort = 1;
    }
    else if(this.functionSet.contains(tmpStr)){
      tmpShort = 2;
    }
    return tmpShort;
  }
  //
  public Program getArgument(short i){
    List tempExpr = new ArrayList();
    List tempExpr1 = new ArrayList();
    List tempExpr2 = new ArrayList();
    short tempShort1=(short)(1);
    short tempShort2;
    short tempShort3;
    if (i==0){
      tempExpr = this.subTree(tempShort1);
    }
    else if (i==1){
      tempShort2 =  (short)(this.subTree(tempShort1).size()+tempShort1);
      tempExpr = this.subTree(tempShort2);
    }
    else if (i==2){
      tempShort2 = (short)(this.subTree(tempShort1).size()+tempShort1);
      tempShort3 = (short)(this.subTree(tempShort2).size()+tempShort2);
      tempExpr = this.subTree(tempShort3);
    }
    else{
      System.out.println("Not a valid argument number");
    }
    return new Program(tempExpr);
  }
  //
  public List getFunctionSet(){
    return this.functionSet;
  }
  //  Method to set the stored expression of this program
  public void setExpression(List expression){
    this.expression.clear();
    this.expression.addAll(expression);
  }
  //  Method to set the stored value of this program
  public void setValue(byte value){
    this.value = value;
  }
  //
  public void setIndicatorSet(List indicators){
    this.indicatorSet.addAll(indicators);
  }
  //
  public void setDecisionSet(List decisions){
    this.decisionSet.addAll(decisions);
  }
  //
  public void setFunctionSet(List functions){
    this.functionSet.addAll(functions);
  }
  public void insertElemExpresion(int index, String expr){
    this.expression.add(index,expr);
  }
  public void deleteElemExpression(int index){
    this.expression.remove(index);
  }
  //  Method for evaluating this program
  public byte evaluation(short n, DataRecord dataRow){
    byte tempByte = 0;
    short tempShort0 = 0,tempShort1 = (short)(n+1),tempShort2, tempShort3;
    List tempExp1 = new ArrayList(),tempExp2 = new ArrayList(),tempExp3 = new ArrayList();
    if (expression.size()>1){
      tempExp1 = this.subTree(tempShort1);
      tempShort2 = (short) (tempShort1+tempExp1.size());
      tempExp2 = this.subTree(tempShort2);
      tempShort3 = (short) (tempShort2+tempExp2.size());
      tempExp3 = this.subTree(tempShort3);
    }
    if(this.decisionSet.contains(expression.get(0))){
      if (((String)expression.get(0)).compareTo("BUY")==0){
        tempByte = (byte) 1;
      }
      else if (((String)expression.get(0)).compareTo("SELL")==0){
        tempByte = (byte) -1;
      }
    }
    else if (evaluateLogicalFunction(tempShort1, dataRow)){
      tempByte = (new Program(tempExp2)).evaluation(tempShort0,dataRow);
    }
    else{
      tempByte = (new Program(tempExp3)).evaluation(tempShort0,dataRow);
    }
    return tempByte;
  }
  //
  public boolean evaluateLogicalFunction(short n, DataRecord dataRow){
    boolean tempBool = false;
    short tempShort1 = (short)(n+1);
    short tempShort2 = (short)(n+2);
    List tempExpr = new ArrayList();
    String tempString = (String)expression.get(n);
    if (tempString.compareTo("NOT")==0){
      tempBool = !(evaluateLogicalFunction(tempShort1,dataRow));
    }
    else if (tempString.compareTo("AND")==0){
      tempExpr = this.subTree(tempShort1);
      tempShort2 = (short) (tempShort1+tempExpr.size());
      tempBool = (evaluateLogicalFunction(tempShort1,dataRow))&&(evaluateLogicalFunction(tempShort2,dataRow));
    }
    else if (tempString.compareTo("OR")==0){
      tempExpr = this.subTree(tempShort1);
      tempShort2 = (short) (tempShort1+tempExpr.size());
      tempBool = (evaluateLogicalFunction(tempShort1,dataRow))||(evaluateLogicalFunction(tempShort2,dataRow));
    }
    else{
      tempBool = evaluateRelationalFunction(n,dataRow);
    }
    return tempBool;
  }
  //
  public boolean evaluateRelationalFunction (short n, DataRecord dataRow){
    boolean tempBool = false;
    short tempShort1 = (short)(n+1);
    short tempShort2 = (short)(n+2);
    String tempString = (String)expression.get(n);
    if (tempString.compareTo("=")==0){
      tempBool=(getIndicator(dataRow,tempShort1)>=(getThreshold(tempShort2)-EPSILON))&&(getIndicator(dataRow,tempShort1)<=(getThreshold(tempShort2)+EPSILON));
    }
    else if (tempString.compareTo("<")==0){
      tempBool = (getIndicator(dataRow,tempShort1)<getThreshold(tempShort2));
    }
    else if (tempString.compareTo(">")==0){
      tempBool = (getIndicator(dataRow,tempShort1)>getThreshold(tempShort2));
    }
    return tempBool;
  }
  //
  private double getIndicator(DataRecord dataRow, short n){
    double tempDouble=0;
    String tempString = (String) expression.get(n);
    if (tempString.compareTo("MV_12")==0)
      tempDouble = dataRow.getMV_12();
    else if (tempString.compareTo("MV_50")==0)
      tempDouble = dataRow.getMV_50();
    else if  (tempString.compareTo("Filter_5")==0)
      tempDouble = dataRow.getFilter_5();
    else if  (tempString.compareTo("Filter_63")==0)
      tempDouble = dataRow.getFilter_63();
    else if  (tempString.compareTo("TRB_5")==0)
      tempDouble = dataRow.getTRB_5();
    else if  (tempString.compareTo("TRB_50")==0)
      tempDouble = dataRow.getTRB_50();
    else if  (tempString.compareTo("VOL_12")==0)
      tempDouble = dataRow.getVOL_12();
    else if  (tempString.compareTo("VOL_50")==0)
      tempDouble = dataRow.getVOL_50();
    else if  (tempString.compareTo("MOM_10")==0)
      tempDouble = dataRow.getMOM_10();
    else if  (tempString.compareTo("MOM_60")==0)
      tempDouble = dataRow.getMOM_60();
    else if  (tempString.compareTo("MMA_10")==0)
      tempDouble = dataRow.getMMA_10();
    else if  (tempString.compareTo("MMA_60")==0)
      tempDouble = dataRow.getMMA_60();
    else
      System.out.println("Error in class Indicator: Not a valid indicator");
    return tempDouble;
  }
  //
  private double getThreshold(short n){
    double tempDouble=0;
    String tempStr = (String) expression.get(n);
    if (isThreshold(tempStr)){
      tempDouble = Double.parseDouble(tempStr);
    }
    else{
      System.out.println("Program: Not a Threshold value");
    }
    return tempDouble;
  }
  //  Method that returns the depth of this program
  public short depth(){
    short l = 0;
    List tempExpr1,tempExpr2,tempExpr3;
    String tmpStr = (String)this.expression.get(0);
    short tempShort1 = 1,tempShort2, tempShort3;
    if (tmpStr.compareTo("ITE")==0){
      l = (short)(Math.max(l,new Program(this.subTree(tempShort1)).depth()));
      tempShort2 = (short) (this.subTree(tempShort1).size()+tempShort1);
      l = (short)(Math.max(l,new Program(this.subTree(tempShort2)).depth()));
      tempShort3 = (short) (this.subTree(tempShort2).size()+tempShort2);
      l = (short)(Math.max(l,new Program(this.subTree(tempShort3)).depth()));
    }
    else if (tmpStr.compareTo("NOT")==0){
      l = (short)(Math.max(l,new Program(this.subTree(tempShort1)).depth()));
    }
    else if(this.functionSet.contains(tmpStr)){
      l = (short)(Math.max(l,new Program(this.subTree(tempShort1)).depth()));
      tempShort2 = (short) (this.subTree(tempShort1).size()+tempShort1);
      l = (short)(Math.max(l,new Program(this.subTree(tempShort2)).depth()));
    }
    return (short)(l+1);
  }
  //  Method that returns the size of this program
  public short size(){
    return (short) expression.size();
  }
  //  Method that returns the number of leaves of this program
  public short leaves(){
    short l = 0;
    List tempExpr1,tempExpr2,tempExpr3;
    String tmpStr = (String)this.expression.get(0);
    short tempShort1 = 1,tempShort2, tempShort3;
    if (tmpStr.compareTo("ITE")==0){
      l += (short)(new Program(this.subTree(tempShort1)).leaves());
      tempShort2 = (short) (this.subTree(tempShort1).size()+tempShort1);
      l += (short)(new Program(this.subTree(tempShort2)).leaves());
      tempShort3 = (short) (this.subTree(tempShort2).size()+tempShort2);
      l += (short)(new Program(this.subTree(tempShort3)).leaves());
    }
    else if (tmpStr.compareTo("NOT")==0){
      l += (short)(new Program(this.subTree(tempShort1)).leaves());
    }
    else if(this.functionSet.contains(tmpStr)){
      l += (short)(new Program(this.subTree(tempShort1)).leaves());
      tempShort2 = (short) (this.subTree(tempShort1).size()+tempShort1);
      l += (short)(new Program(this.subTree(tempShort2)).leaves());
    }
    else{
      l=1;
    }
    return (short) (l);
  }
  //  Method that returns the tree under the program n
  public List subTree(short n){
    List tempExpr = new ArrayList();
    String tempStr = (String) expression.get(n);
    if (n == 0){
      tempExpr.addAll(this.expression);
      return tempExpr;
    }
    else if (tempStr.compareTo("ITE")==0){
      return getThreeArgFunct(expression,n);
    }
    else if (tempStr.compareTo("NOT")==0){
      return  getOneArgFunct(expression,n);
    }
    else if ( (tempStr.compareTo("AND")==0)||(tempStr.compareTo("OR")==0)||(tempStr.compareTo("<")==0)
              ||(tempStr.compareTo(">")==0)||(tempStr.compareTo("=")==0)){
      return  getTwoArgFunct(expression,n);
    }
    else {
      return  getTerminal(expression,n);
    }
  }
  //
  private List getThreeArgFunct(List expression, short n){
    List tempExp = new ArrayList();
    List tempExp1 = new ArrayList();
    List tempExp2 = new ArrayList();
    List tempExp3 = new ArrayList();
    short tempShort1=(short)(n+1);
    short tempShort2;
    short tempShort3;
    String tempStr=(String)expression.get(n);
    tempExp1 = subTree(tempShort1);
    tempShort2 = (short)(tempShort1+tempExp1.size());
    tempExp.add(tempStr);
    tempExp.addAll(tempExp1);
    tempExp2 = subTree(tempShort2);
    tempExp.addAll(tempExp2);
    tempShort3 = (short)(tempShort2+tempExp2.size());
    tempExp3 = subTree(tempShort3);
    tempExp.addAll(tempExp3);
    return tempExp;
  }
  //
  private List getTwoArgFunct(List expression, short n){
    List tempExp = new ArrayList();
    List tempExp2 = new ArrayList();
    String tempStr=(String)expression.get(n);
    short tempShort1=(short)(n+1);
    short tempShort2=(short)(tempShort1+1);
    tempExp.add(tempStr);
    if ((tempStr.compareTo("<")==0)||(tempStr.compareTo(">")==0)||(tempStr.compareTo("=")==0)){
      tempExp.add(expression.get(tempShort1));
      tempExp.add(expression.get(tempShort2));
    }
    else if ( (((String)expression.get(tempShort1)).compareTo("NOT")==0)&&
              (((String)expression.get((short)(tempShort1+getOneArgFunct(expression,tempShort1).size()))).compareTo("NOT")==0)){
      tempExp2.addAll(getOneArgFunct(expression, tempShort1));
      tempExp.addAll(tempExp2);
      tempShort2 = (short)(tempShort1+tempExp2.size());
      tempExp.addAll(getOneArgFunct(expression, tempShort2));
    }
    else if (((String)expression.get(tempShort1)).compareTo("NOT")==0){
      tempExp2.addAll(getOneArgFunct(expression, tempShort1));
      tempExp.addAll(tempExp2);
      tempShort2 = (short)(tempShort1+tempExp2.size());
      tempExp.addAll(getTwoArgFunct(expression, tempShort2));
    }
    else if (((String)expression.get((short)(tempShort1+getTwoArgFunct(expression,tempShort1).size()))).compareTo("NOT")==0){
      tempExp2.addAll(getTwoArgFunct(expression, tempShort1));
      tempExp.addAll(tempExp2);
      tempShort2 = (short)(tempShort1+tempExp2.size());
      tempExp.addAll(getOneArgFunct(expression, tempShort2));
    }
    else {
      tempExp2.addAll(getTwoArgFunct(expression, tempShort1));
      tempExp.addAll(tempExp2);
      tempShort2 = (short)(tempShort1+tempExp2.size());
      tempExp.addAll(getTwoArgFunct(expression, tempShort2));
    }
    return tempExp;
  }
  //
  private List getOneArgFunct(List expression, short n){
    List tempExp = new ArrayList();
    String tempStr = (String)expression.get(n);
    short tempShort=(short)(n+1);
    tempExp.add(tempStr);
    if ( ((String)expression.get(tempShort)).compareTo("NOT")==0 ){
      tempExp.addAll(getOneArgFunct(expression,tempShort));
    }
    else{
      tempExp.addAll(getTwoArgFunct(expression,tempShort));
    }
    return (tempExp);
  }
  //
  private List getTerminal(List expression, short n){
    List tempExp = new ArrayList();
    tempExp.add(expression.get(n));
    return (tempExp);
  }
  //  Method that replaces the tree under the program n with the tree in the second argument
  public void replaceTree(short n, List expression){
    List tempExp = new ArrayList();
    List tempExp1 = new ArrayList();
    short tempShort1;
//    String tempStr = (String)expression.get(n);
    if (n==0){
      this.expression.clear();
      this.expression.addAll(expression);
    }
    else{
      tempExp.addAll(this.expression.subList(0,(n)));
      tempExp1.addAll(subTree(n));
      tempExp.addAll(expression);
      tempShort1 = (short) (n+tempExp1.size());
      if (tempShort1<this.expression.size())
        tempExp.addAll(this.expression.subList(tempShort1,(this.expression.size())));
      this.expression.clear();
      this.expression.addAll(tempExp);
    }
  }
  //  Method that returns a boolean value true, if both lists are compatible among each other otherwise returns false
  public boolean isCompatible(List e1, List e2){
    String tempStr1 = (String) e1.get(0);
    String tempStr2 = (String) e2.get(0);
    boolean tempBool = false;
    if (tempStr1.compareTo(tempStr2) == 0)
      tempBool = true;
    else if (decisionSet.contains(tempStr1)&&decisionSet.contains(tempStr2))
      tempBool = true;
    else if ((tempStr1.compareTo("ITE")==0&&decisionSet.contains(tempStr2))||(decisionSet.contains(tempStr1)&&tempStr2.compareTo("ITE")==0) )
      tempBool = true;
    else if ( functionSet.contains(tempStr1)&&functionSet.contains(tempStr2)&&!((tempStr1.compareTo("ITE")==0)||(tempStr2.compareTo("ITE")==0)) )
      tempBool = true;
    else if (indicatorSet.contains(tempStr1)&&indicatorSet.contains(tempStr2))
      return true;
    else if (isThreshold(tempStr1)&&isThreshold(tempStr2))
      return true;
    return tempBool;
  }
  // Methos that validates if a given string is valid numeric value
  public boolean isThreshold(String str){
    boolean tempBool = true;
    try {
      Float.parseFloat(str);
    }
    catch(NumberFormatException e){
      tempBool = false;
    }
    return tempBool;
  }
  //  Method that clones this program
  public Object clone(){
    List tempList = new ArrayList();
    tempList.addAll(this.expression);
    byte tempVal = this.value;
    return new Program(tempList, tempVal);
  }
  //  Method that prints this program
  public void print(){
    System.out.println(this.toString());
  }
  //  Method that converts to string this program
  public String toString(){
    return expression.toString();
  }
}