package stockMarketApplet.market.io;

import java.io.*;

public class InputGroupParameters {
  private  FileInputStream fileName;
  private  GroupParametersRecord groupsParamRec[];

  public GroupParametersRecord[] readGroupsGroupParameters(int numberGroupsTraders){
    groupsParamRec = new GroupParametersRecord[numberGroupsTraders];
    String fileNameStringCommon = "parameters/GroupParameters";
    String fileNameString;
    for (int i=0; i  < numberGroupsTraders;i++){
      fileNameString = fileNameStringCommon + i + ".txt";
      try{
            fileName = new FileInputStream(fileNameString);
      } catch(FileNotFoundException e) {
            System.out.print("File Not Found");
      }
      groupsParamRec[i] = new GroupParametersRecord();
      groupsParamRec[i].setNumTraders( (new Integer(readLine())).intValue() );
      groupsParamRec[i].setDays ((new Integer(readLine())).intValue());
      groupsParamRec[i].setRate((new Double(readLine())).doubleValue());
      groupsParamRec[i].setCash((new Double(readLine())).doubleValue());
      groupsParamRec[i].setNumberShares((new Double(readLine())).doubleValue());
      groupsParamRec[i].setMemoryLenght((new Integer(readLine())).intValue());
      groupsParamRec[i].setRetrainningCondition(new Integer(readLine()).byteValue());
      groupsParamRec[i].setFixedRetrainningPeriodicity(new Integer(readLine()).intValue());
      groupsParamRec[i].setFitnessFunctionType(new Integer(readLine()).byteValue());
      groupsParamRec[i].setLimitOrderSellGeneration(new Integer(readLine()).byteValue());
      groupsParamRec[i].setLimitOrderBuyGeneration(new Integer(readLine()).byteValue());
      groupsParamRec[i].setFundamentalBehaviour(new Integer(readLine()).byteValue());
      groupsParamRec[i].setTmin((new Double(readLine())).doubleValue());
      groupsParamRec[i].setTmax((new Double(readLine())).doubleValue());
      groupsParamRec[i].setTauMin((new Double(readLine())).doubleValue());
      groupsParamRec[i].setTauMax((new Double(readLine())).doubleValue());
      groupsParamRec[i].setA((new Double(readLine())).doubleValue());
      try
      {
      fileName.close();
      } catch (IOException e){
        System.out.print("Can not close the file");
      }
    }
    return groupsParamRec;
  }
  public GroupParametersRecord readGroupParameters(int numberGroup){
    GroupParametersRecord groupParamRec = new GroupParametersRecord();
    String fileNameString = "parameters/GroupParameters"+numberGroup+".txt";
    try{
      fileName = new FileInputStream(fileNameString);
    } catch(FileNotFoundException e) {
      System.out.print("File Not Found");
    }
      groupParamRec.setNumTraders( (new Integer(readLine())).intValue() );
      groupParamRec.setDays ((new Integer(readLine())).intValue());
      groupParamRec.setRate((new Double(readLine())).doubleValue());
      groupParamRec.setCash((new Double(readLine())).doubleValue());
      groupParamRec.setNumberShares((new Double(readLine())).doubleValue());
      groupParamRec.setMemoryLenght((new Integer(readLine())).intValue());
      groupParamRec.setRetrainningCondition(new Integer(readLine()).byteValue());
      groupParamRec.setFixedRetrainningPeriodicity(new Integer(readLine()).intValue());
      groupParamRec.setFitnessFunctionType(new Integer(readLine()).byteValue());
      groupParamRec.setLimitOrderSellGeneration(new Integer(readLine()).byteValue());
      groupParamRec.setLimitOrderBuyGeneration(new Integer(readLine()).byteValue());
      groupParamRec.setFundamentalBehaviour(new Integer(readLine()).byteValue());
      groupParamRec.setTmin((new Double(readLine())).doubleValue());
      groupParamRec.setTmax((new Double(readLine())).doubleValue());
      groupParamRec.setTauMin((new Double(readLine())).doubleValue());
      groupParamRec.setTauMax((new Double(readLine())).doubleValue());
      groupParamRec.setA((new Double(readLine())).doubleValue());

    try
    {
      fileName.close();
    } catch (IOException e){
      System.out.print("Can not close the file");
    }
    return groupParamRec;
  }
  private  String readLine(){
    int c;
    int cr = 13;
    String bufferLine = new String();
    try{
        c = fileName.read();
        while (c!=cr && c!=-1) {
          bufferLine += (char)(c);
          c = fileName.read();
        }
        fileName.skip(1);
    } catch(IOException e) {
      System.out.print("IO Exception: " + e.getMessage());
    }catch(ArrayIndexOutOfBoundsException e1){
      System.out.print("Array Index Out Of Bounds Exception: " + e1.getMessage());
    }
    return bufferLine;
  }

}