package stockMarketApplet.util;

import java.io.*;
import java.awt.*;
import java.util.List;
import java.util.Random;
import java.util.ArrayList;
import stockMarketApplet.market.io.DataRecord;
import stockMarketApplet.market.agents.technicalTrader.basics.Individual;
import stockMarketApplet.market.agents.technicalTrader.TechnicalTrader;
import stockMarketApplet.market.io.GroupParametersRecord;

public class Util {

  public Util() {
  }
  public void constraints(Container container, Component component, GridBagConstraints c,
                          int grid_x, int grid_y, int fill, int anchor,
                          int grid_with, int grid_height, double weight_x, double weight_y
                          )
  {
    c.gridx = grid_x;
    c.gridy = grid_y;
    c.fill = fill;
    c.anchor = anchor;
    c.gridwidth = grid_with;
    c.gridheight = grid_height;
    c.weightx = weight_x;
    c.weighty = weight_y;
    container.add(component,c);
  }
  public void constraints(Container container, Component component, GridBagConstraints c,
                          int grid_x, int grid_y, int fill, int anchor,
                          int grid_with, int grid_height
                          )
  {
    c.gridx = grid_x;
    c.gridy = grid_y;
    c.fill = fill;
    c.anchor = anchor;
    c.gridwidth = grid_with;
    c.gridheight = grid_height;
    container.add(component,c);
  }
  // Used to add elements to a container with GridBoxLayout
  public void constrain(Container container, Component component,
			int grid_x, int grid_y, int grid_width, int grid_height,
			int fill, int anchor,double weight_x, double weight_y,
			int top, int left, int bottom, int right)
  {
    GridBagConstraints c = new GridBagConstraints();
    c.gridx = grid_x; c.gridy = grid_y;
    c.gridwidth = grid_width; c.gridheight = grid_height;
    c.fill = fill; c.anchor = anchor;
    c.weightx = weight_x; c.weighty = weight_y;
    if( top+bottom+left+right > 0)
      c.insets = new Insets(top, left, bottom, right );
    ((GridBagLayout)container.getLayout()).setConstraints(component, c);
    container.add(component);
  }
  // Used to add elements to a container with GridBoxLayout
  public void constrain( Container container, Component component,
			 int grid_x, int grid_y, int grid_width, int grid_height)
  {
    constrain(container,component,grid_x, grid_y,
	      grid_width, grid_height, GridBagConstraints.NONE,
	      GridBagConstraints.NORTHWEST,0.0,0.0,0,0,0,0);
  }
  // Used to add elements to a container with GridBoxLayout
  public void constrain( Container container, Component component,
			 int grid_x, int grid_y, int grid_width, int grid_height,
			 int top, int left, int bottom, int right)
  {
    constrain(container,component,grid_x,grid_y,
		   grid_width, grid_height, GridBagConstraints.NONE,
		   GridBagConstraints.NORTHWEST,
		   0.0,0.0,top,left,bottom,right);
  }
  //  Quicksort algorithm
  static public void QuickSort(Individual a[], int lo0, int hi0)  {
    int lo = lo0;
    int hi = hi0;
    Individual mid;
    if ( hi0 > lo0)
    {
      mid = a[ ( lo0 + hi0 ) / 2 ];
      while( lo <= hi )
      {
	while( ( lo < hi0 ) && ( a[lo].getFitness() > mid.getFitness() ) )
	  ++lo;
	while( ( hi > lo0 ) && ( a[hi].getFitness() < mid.getFitness() ) )
	  --hi;
	if( lo <= hi )
        {
	  swap(a, lo, hi);
	  ++lo;
	  --hi;
	}
      }
      if( lo0 < hi )
	QuickSort( a, lo0, hi );
      if( lo < hi0 )
	QuickSort( a, lo, hi0 );
    }
  }
  //  Standard swap method
  static private void swap(Individual a[], int i, int j)
  {
    Individual T;
    T = a[i];
    a[i] = a[j];
    a[j] = T;
  }

  public void QuickSort(TechnicalTrader a[], int lo0, int hi0)  {
    int lo = lo0;
    int hi = hi0;
    TechnicalTrader mid;
    if ( hi0 > lo0)
    {
      mid = a[ ( lo0 + hi0 ) / 2 ];
      while( lo <= hi )
      {
	while( ( lo < hi0 ) && ( a[lo].getWealth() > mid.getWealth() ) )
	  ++lo;
	while( ( hi > lo0 ) && ( a[hi].getWealth() < mid.getWealth() ) )
	  --hi;
	if( lo <= hi )
        {
	  swap(a, lo, hi);
	  ++lo;
	  --hi;
	}
      }
      if( lo0 < hi )
	QuickSort( a, lo0, hi );
      if( lo < hi0 )
	QuickSort( a, lo, hi0 );
    }
  }
  private void swap(TechnicalTrader a[], int i, int j)  {
    TechnicalTrader T;
    T = a[i];
    a[i] = a[j];
    a[j] = T;
  }
  public static void copyParametersFiles(String directoryName){
    File srcDir = new File("parameters"), dstDir = new File(directoryName);
    String children[] = srcDir.list();
    for (int i=0; i<children.length; i++) {
      File src = new File(srcDir, children[i]), dst = new File(dstDir, children[i]);
      try {
        InputStream in = new FileInputStream(src);
        OutputStream out = new FileOutputStream(dst);
        // Transfer bytes from in to out
        byte[] buf = new byte[1024];
        int len;
        while ((len = in.read(buf)) > 0) {
            out.write(buf, 0, len);
        }
        in.close();
        out.close();
      }catch (IOException  e1){
        System.out.print("IO Exception: " + e1.getMessage());
      }
    }
  }
  public int getGroupNumber(GroupParametersRecord[] groupsParameters,int technicalTraderNumber){
    int temp = 0;
    int groupNumber=0;
    boolean flag=true;
    for (int i = 0;i<groupsParameters.length&&flag;i++){
      if (technicalTraderNumber>=temp){
        groupNumber = i;
      }
      else{
        flag=false;
      }
      temp+=groupsParameters[i].getNumTraders();
    }
    return groupNumber;
  }

  public double getRandomNormal(Random rand, double mean, double stddev){
    double temp;
    temp = (rand.nextGaussian()*stddev)+mean;
    return temp;
  }

  public  double computeMax(DataRecord[] serie){
    double temp = serie[0].getObservation();
    for (int i = 0; i < serie.length ; i++){
      if (temp < serie[i].getObservation()){
        temp = serie[i].getObservation();
      }
    }
    return temp;
  }

  public  double computeMin(DataRecord[] serie){
    double temp = serie[0].getObservation();
    for (int i = 0; i < serie.length ; i++){
      if (temp > serie[i].getObservation()){
        temp = serie[i].getObservation();
      }
    }
    return temp;
  }

  public double computeAverage(DataRecord[] serie, String field){
    double sum = 0.0;
    if (field=="MOM_10"){
      for (int i = 0; i < serie.length ; i++){
        sum += serie[i].getMOM_10();
      }
    }
    else{
      for (int i = 0; i < serie.length ; i++){
        sum += serie[i].getMOM_60();
      }
    }
    return sum/(serie.length);
  }

  public double computeAverage(DataRecord[] serie){
    double sum = 0.0;
    for (int i = 0; i < serie.length ; i++){
      sum += serie[i].getObservation();
    }
    return sum/(serie.length);
  }

  public double computeStdDev(DataRecord[] serie){
    double sum = 0, sqrsum = 0, temp;
    for (int i = 0; i < serie.length ; i++){
      sum += serie[i].getObservation();
      sqrsum += Math.pow(serie[i].getObservation(),2.0);
    }
    sum = Math.pow(sum,2.0);
    temp = ( (serie.length*sqrsum)-sum ) / ( serie.length * (serie.length -1) );
    return Math.sqrt(temp);
  }

  public DataRecord[] subarray(DataRecord[] array, int lowerBound, int upperBound){
    DataRecord[] tempData = new DataRecord[(upperBound - lowerBound) + 1];
    for (int i = 0; i < tempData.length ; i++){
      tempData[i] = array[i + lowerBound];
    }
    return tempData;
  }

  static public List interpretString(String line){
    List tmpLst = new ArrayList();
    String tmpStr = new String();
    int c;
    int coma = 44;
    int lsb = 91;
    int rsb = 93;
    int i=0;
    c = line.charAt(i);
    while (c!=lsb){
      tmpStr += (char)(c);
      i++;
      c = line.charAt(i);
    }
    tmpLst.add(tmpStr);
    tmpStr=new String();
    i++;
    c = line.charAt(i);
    while (c!=rsb) {
      tmpStr += (char)(c);
      i++;
      c = line.charAt(i);
      if (c==coma){
        tmpLst.add(tmpStr);
        tmpStr=new String();
        i+=2;
        c = line.charAt(i);
      }
      if (c==rsb){
        tmpLst.add(tmpStr);
      }
    }
    return tmpLst;
  }

}